/*
  UART-Init: 
Berechnung des Wertes fr das Baudratenregister 
aus Taktrate und gewnschter Baudrate*/

 
#ifndef F_CPU
/* In neueren Version der WinAVR/Mfile Makefile-Vorlage kann
   F_CPU im Makefile definiert werden, eine nochmalige Definition
   hier wuerde zu einer Compilerwarnung fuehren. Daher "Schutz" durch
   #ifndef/#endif 
 
   Dieser "Schutz" kann zu Debugsessions fhren, wenn AVRStudio 
   verwendet wird und dort eine andere, nicht zur Hardware passende 
   Taktrate eingestellt ist: Dann wird die folgende Definition 
   nicht verwendet, sondern stattdessen der Defaultwert (8 MHz?) 
   von AVRStudio - daher Ausgabe einer Warnung falls F_CPU
   noch nicht definiert: */
#warning "F_CPU war noch nicht definiert, wird nun nachgeholt mit 16000000"
#define F_CPU 16000000UL  							// systemclock in Hz - definition as unsigned long !!
                         
#endif
 
#define BAUD 600UL      							// real Baudrate at 9600!!!
 
// calculation
#define UBRR_VAL ((F_CPU+BAUD*8)/(BAUD*16)-1)   	// approximate professional
#define BAUD_REAL (F_CPU/(16*(UBRR_VAL+1)))     	// real Baudrate
#define BAUD_ERROR ((BAUD_REAL*1000)/BAUD) 			// error in mil, 1000 = no error.
 
#if ((BAUD_ERROR<990) || (BAUD_ERROR>1010))
  #error Systematischer Fehler der Baudrate grsser 1% und damit zu hoch! 
#endif 
